// Generated by dts-bundle-generator v9.5.1

import { Schema } from 'dtsgenerator';
import { OpenApisV2 } from 'dtsgenerator/dist/core/openApiV2';
import { OpenApisV3 } from 'dtsgenerator/dist/core/openApiV3';

export type Operation = OpenApisV2.SchemaJson.Definitions.Operation | OpenApisV3.SchemaJson.Definitions.Operation;
export type ResponseValue = OpenApisV2.SchemaJson.Definitions.ResponseValue | OpenApisV3.SchemaJson.Definitions.ResponseOrReference;
declare enum WriteFileMode {
	/**
	 * overwrite file if exists
	 */
	overwrite = "overwrite",
	/**
	 * skip if file exists
	 */
	skip = "skip",
	/**
	 * warn if file exists
	 */
	warn = "warn",
	/**
	 * error if file exists
	 */
	error = "error"
}
export interface ServiceDescriptor {
	name: string;
	title: string;
	description: string;
	version: string;
	host: string;
	basePath: string;
}
export type ParsedOperation = Operation & {
	uri: string;
	method: string;
	operationId: string;
	successResponse?: ResponseValue;
};
export interface ParserResult extends Record<string, any> {
	schema: Schema;
	definition: string;
	apis: ParsedOperation[];
	service: ServiceDescriptor;
	tags: string[];
}
export interface IOpenAPIPlugin {
	transform: (result: ParserResult) => void | Promise<void>;
}
export interface OpenAPIPluginOptions {
	cwd?: string;
}
declare abstract class OpenAPIPlugin<T extends OpenAPIPluginOptions> implements IOpenAPIPlugin {
	options: T;
	constructor(options: T);
	abstract transform: (result: ParserResult) => void | Promise<void>;
}
export type PluginWriteFileMode = string | WriteFileMode | {
	api?: WriteFileMode;
	service?: WriteFileMode;
};
export interface OpenAPITransformAppPluginOptions extends OpenAPIPluginOptions {
	apiDir?: string;
	serviceDir?: string;
	dtsDir?: string;
	extractPath?: string;
	/**
	 * extract field from response data
	 * @example extractField = 'data'
	 */
	extractField?: string | string[];
	baseUrl?: string | ((extractPath?: string) => void);
	/**
	 * write file mode
	 * @default 'warn'
	 */
	writeFileMode?: WriteFileMode | {
		api?: WriteFileMode;
		service?: WriteFileMode;
	};
	/**
	 * config param type name
	 * @default AxiosRequestConfig
	 */
	configParamTypeName?: string;
	/**
	 * service import path
	 */
	serviceImportPath?: string;
	/**
	 * apis include filter
	 */
	include?: ((api: ParsedOperation) => boolean) | RegExp | string[];
	/**
	 * apis exclude filter
	 */
	exclude?: ((api: ParsedOperation) => boolean) | RegExp | string[];
}
declare class OpenAPITransformAppPlugin extends OpenAPIPlugin<OpenAPITransformAppPluginOptions> {
	transform: ({ apis, definition, service, schema }: ParserResult) => Promise<void>;
	private outputDts;
	private joinUrl;
	private outputService;
	private outputApis;
	private createServiceImport;
	private adaptorWriteFileModeArgs;
}

export {
	OpenAPITransformAppPlugin as default,
};

export {};
